import React, { Component } from 'react'
import "./chart.css"
import { message, Button, Row, Col, Menu, Dropdown, Icon, Spin, Alert } from "antd"
import TdCmpName from '../common/TdCmpName'
import SearchFields from '../common/searchfields/'
import DetailModal from "./DetailModal"
import { Highcharts } from "react-highcharts"
import HighchartsMore from "./highcharts/highcharts-more"
import HighchartsGroupedCategories from "./highcharts/grouped-categories"
import screenCategories from "./highcharts/screenCategories"

var ReactHighcharts = require('react-highcharts');
// Highcharts exporting
var HighchartsExporting = require('highcharts-exporting');
HighchartsExporting(ReactHighcharts.Highcharts);
var HighchartsExportingCsv = require('highcharts-export-csv');
HighchartsExportingCsv(ReactHighcharts.Highcharts);
var HighchartsOfflineExporting = require('highcharts-offline-exporting')
HighchartsOfflineExporting(ReactHighcharts.Highcharts);
HighchartsGroupedCategories(Highcharts)
HighchartsMore(Highcharts)

class Chart extends Component {
	constructor(props) {
		super(props)
		this.state = {
            loading: true,
            isError: false,
            errorText: '',
			detailModalVisible: false,
			mostWidth: 1,
			direction: "",
            rep_name: '',
            res: [],
            chart_type: '',
            x_axis_fields: [],
            y_axis_fields: [],
            i_dataset: '',
            forecolor_value:'',
            tableData: [],
            searchParams: [],
            selec_data:[],
            category_fileds: '',
            series_fields: '',
            cache_span: '',
            method:[],
            dataType:[],
            currentClickInfo: null,
            showElIdRef: "reportPreviewWrapper" + Math.random().toString() + "",
            dataFilterParams:[],
            link_type: props.linkType?true:false,
            slot:props.slot,
            dataLink:[],
            rename_filed:{}
        },
        this.forecolor_array = [
            ['#2f7ed8', '#e0522f', '#ffcc00', '#10cca6', '#6bb61d', '#f2a21a', '#ff7372', '#a5e8d2', '#9ce810', '#fff80a', '#1dcfab', '#858e54'],
            ['#138cdd', '#fda122', '#ff7372', '#4ebff9', '#8bcb2e', '#a97aca', '#b3e7d6', '#fce997', '#fcdaaa', '#fed2de', '#5f9baf', '#dd0ab2'],
            ['#bb1d48', '#5435ae', '#ffcc00', '#e0522f', '#6bb61d', '#2e8bef', '#a97aca', '#f59bb3', '#2ecb70', '#f2c40f', '#8f6f4d', '#ff8947'],
            ['#0e94db', '#ffbf01', '#6ab206', '#128ece', '#f13158', '#f86031', '#8350c6', '#bbde5b', '#dea15b', '#77bfd1', '#c6868e', '#aab300'],
            ['#9b0d27', '#fe9721', '#0e94db', '#e87a69', '#000000', '#ffff00', '#90c543', '#428190', '#b5634b', '#c1de34', '#e30450', '#654458']
        ]
        this.myRepChartInstance = null
	}
	closeDetailModal = () => {
		this.setState({
			detailModalVisible: false
		})
    }
	initInstance() {
        this.myRepChartInstance = null
        this.myRepChartInstance = new Highcharts.Chart(this.state.showElIdRef, { ...setting })		
	}
    getClickInfo(obj, callback){
        const me = this
        let { 
            reportInfo
        } = this.state
        jQuery.post('/general/appbuilder/web/report/repchart/data', {
            ...obj
        }, (response) => {
            let tableData = JSON.parse(response)
            let nextReportInfo = {...reportInfo}
            nextReportInfo['tableData'] = tableData
            me.setState({
                reportInfo: nextReportInfo
            })
            callback && callback()
        })
    }
    handleExportMenuClick(e) {
		if(e.key ==='1'){
            window.location.href = `/general/appbuilder/web/report/repchart/export?id=${this.props.reportId}&category=excel&method=${JSON.stringify(this.state.method)}&searchParams=${JSON.stringify(this.state.searchParams.concat(this.state.dataFilterParams))}`;
		}else if(e.key === '2'){
			this.myRepChartInstance.exportChartLocal({
				type: 'image/png'
			});
		}else if (e.key === '3') {
			this.myRepChartInstance.exportChartLocal({
				type: 'image/svg+xml'
			});
		}
    }
	render() {
        const me = this
        const exportMenu = (
			<Menu onClick={this.handleExportMenuClick.bind(this)}>
                <Menu.Item className="ui-chart-export-excel" key="1">导出Excel文件</Menu.Item>
				<Menu.Item className="ui-chart-export-png" key="2">导出PNG图片</Menu.Item>
				<Menu.Item className="ui-chart-export-svg" key="3">导出SVG文件</Menu.Item>
			</Menu>
        );

        // let {
		// 	s_categories: xAxisFieldsString,
		// 	s_series: yAxisFieldsString,
		// 	i_dataset: setId,
		// 	params:para
		// } = me.state
		
		// let detailProps = {
		// 	xAxisFieldsString,
		// 	yAxisFieldsString,
		// 	setId,
		// 	para
        // }
        
        Highcharts.setOptions({
			allowHTML: true,
			lang: {
				// printChart: '打印图表',
				// downloadJPEG: '下载 JPEG 文件',
				// downloadPDF: '下载 PDF   文件',
				// downloadPNG: '下载 PNG  文件',
				// downloadSVG: '下载 SVG  文件',
				// downloadCSV: '下载 CSV  文件',
				// downloadXLS: '下载 XLS   文件',
				// viewData: '查看数据表格'
			},
			navigation: {
				buttonOptions: {
					enabled: false
				}
			},
			exporting: {
				chartOptions: { // specific options for the exported image
					plotOptions: {
						series: {
							dataLabels: {
								enabled: true
							}
						}
					}
				},
				fallbackToExportServer: false
			},
        });
        
		let obj = {}
//		console.log(this.state.direction)
//		console.log(this.state.mostWidth*10*0.65)
		if(this.state.direction!=""&&this.state.direction=="width"){
			obj = {"width":`${this.state.mostWidth*16}px`,"height":"100%","minWidth":"100%","minHeight":"100%","paddingTop":"35px"}
		}
		if(this.state.direction!=""&&this.state.direction=="height"){
			obj = {"height":`${this.state.mostWidth*10*0.65}px`,"width":"100%","minWidth":"100%","minHeight":"100%","paddingTop":"35px"}
		}
		if(this.state.direction!=""&&this.state.direction=="normal"){
			obj = {"width":"100%","height":"100%","minWidth":"100%","minHeight":"100%","paddingTop":"35px"}
        }
        let showName = this.props.showName ? true : false
        let showSearchParams = this.props.showSearchParams ? true : false
        let showExport = this.props.showExport ? true : false
        let showPrint = this.props.showPrint ? true : false
		const container = (
            <div>
                <div className="td-cmp-option">
                    {
                        showExport ? <Dropdown overlay={exportMenu}><Button>导出 <Icon type="down" /></Button></Dropdown> : null
                    }
                    {
                        showPrint ? <Button className='ui-chart-print-btn' onClick={() => { me.myRepChartInstance.print(); }}>打印</Button>:null
                    }
                </div>
                <TdCmpName visible={showName} title={this.state.rep_name} />
                <div style={{"width":"100%","margin":"0 auto"}}>
                {
                    showSearchParams && this.state.searchParams.length ? <SearchFields selec_data={this.state.selec_data} searchParams={this.state.searchParams} onSearch={this.onSearch.bind(this)} /> : null
                }
                </div>
                <div className="td-cmp-content">
                    <div className="report-preview" id={this.state.showElIdRef} style={obj}></div>
                    {
                        this.state.detailModalVisible ? <DetailModal {...this.props} showExport={showExport} closeDetailModal={this.closeDetailModal} {...this.state}></DetailModal> : null
                    }
                </div>
			</div>
        )
        let rep_name = this.state.rep_name ? this.state.rep_name : ''
        return this.state.isError ? <Alert
                            message={`“${rep_name}”加载失败`}
                            description={`reportId: ${this.props.reportId} ${this.state.errorText}`}
                            type="info"
                            style={{ marginBottom: 16 }}
                        /> : <Spin spinning={this.state.loading}>{container}</Spin>
    }
    onSearch(searchParams){
        this.setState({
            searchParams
        },()=>{
            this.getData()
        })
    }
	componentDidMount() {
        this.getReportInfo(this.props.reportId);
    }
    getReportInfo = (id) => {
        const me = this
        let slot = me.state.slot
        let link_type = me.state.link_type
        jQuery.post('/general/appbuilder/web/report/repchart/fetch', {
            id,
            slot,
            link_type,
            myrep: !!1
        }, (response) => {
            let res = JSON.parse(response)
            if(res.status=="ok") {
                let {
                    category_fileds,
                    series_fields,
                    dataset_id,
                    chart_type,
                    cache_span,
                    theme: forecolor_value,
                    name: rep_name,
                    data_type,
                    searchParams,
                    selec_data,
                    rename_filed,
                    data_link
                } = res.data
                let newSearchParams = searchParams.filter(function (elem) {
                    if(elem.type_of_reports === 'search'){
                        return elem;
                    }
                })
                let newDataFilterParams = searchParams.filter(function (elem) {
                    if(elem.type_of_reports === 'select'){
                        return elem;
                    }
                })
                me.setState({
                    category_fileds,
                    series_fields,
                    i_dataset: dataset_id,
                    chart_type,
                    cache_span,
                    dataType:data_type?data_type:[],
                    forecolor_value,
                    rep_name,
                    searchParams: newSearchParams,
                    selec_data:selec_data,
                    dataFilterParams: newDataFilterParams,
                    loading: false,
                    dataLink: data_link ? data_link :[],
                    rename_filed:rename_filed?rename_filed:{}
                })
                if(category_fileds===""&&series_fields.length===0){
                    me.setState({
                        loading: false,
                        isError: true,
                        errorText: "请选择至少一种分类或图例"
                    })
                    message.error("请选择至少一种分类或图例")
                    return;
                }
                me.getData()

            }else{
            	if(res.status=="error"){
            		 me.setState({
                    isError: true,
                    errorText: res.message,
                    loading: false
                })
            	}else{
            		 me.setState({
                    isError: true,
                    errorText: "获取报表信息格式错误",
                    loading: false
                })
            	}
               
            }
        }).error(function(e){
            me.setState({
                loading: false,
                isError: true,
                errorText: e.responseText
            })
        })
    }
    getData(){
        const me = this
        const t = this;
        let {
            category_fileds,
            series_fields,
            i_dataset,
            chart_type,
            cache_span,
            forecolor_value,
            rep_name,
            searchParams,
            dataFilterParams,
            dataType
        } = this.state
        const calculationMethods = [
            {
                type: 'sum',
                value: '求和'
            },
            {
                type: 'count',
                value: '计数'
            },
            {
                type: 'distinct',
                value: '数值计数'
            },
            {
                type: 'max',
                value: '最大值'
            },
            {
                type: 'min',
                value: '最小值'
            },
            {
                type: 'avg',
                value: '平均值'
            }
        ];
        let chartIdType = [
            {
                "id": 1, 
                "type": "column"
            }, 
            {
                "id": 2, 
                "type": "stack_column"
            }, 
            {
                "id": 3, 
                "type": "bar"
            }, 
            {
                "id": 4, 
                "type": "stack_bar"
            }, 
            {
                "id": 5, 
                "type": "line"
            }, 
            {
                "id": 6, 
                "type": "area"
            }, 
            {
                "id": 7, 
                "type": "stack_area"
            }, 
            {
                "id": 8, 
                "type": "pie"
            }, 
            {
                "id": 9, 
                "type": "scatter"
            }, 
            {
                "id": 10, 
                "type": "bubble"
            }, 
            {
                "id": 11, 
                "type": "polar"
            }, 
            {
                "id": 12, 
                "type": "gauge"
            }
        ]
        let chart;
        chartIdType.forEach((v, i) => {
            v.id == chart_type && (chart = v.type)
        })
        let params = {
            method: [] //name calculation
        }
        params.id = this.props.reportId;
        params.cache_span = cache_span;
        series_fields.length!==0 && series_fields.split(",").forEach((v, i) => {
            let arr = v.split(" : ")
            if(arr.length > 1) {
                params.method.push({
                    name: arr[1],
                    calculation: function() {
                        for(let i = 0; i < calculationMethods.length; i++) {
                            if(calculationMethods[i].value == arr[0]) return calculationMethods[i].type
                        }
                    }()
                })
            } else {
                params.method.push({
                    name: arr[0],
                    calculation: "sum"
                })
            }
        })
        params.searchParams = searchParams.concat(dataFilterParams)
        params.slot = this.state.slot
        params.rename_filed=me.state.rename_filed
        params.link_type = this.state.link_type
        params.dataLink = this.state.dataLink
        this.setState({
            method: params.method
        })

        jQuery.post('/general/appbuilder/web/report/repchart/data', {
            s_categories: category_fileds,
            s_series: series_fields,
            i_dataset: i_dataset,
            dataType:dataType,
            params
        }, (response) => {
            let x_axis_fields = category_fileds ? category_fileds.split(",") : [],
                y_axis_fields = series_fields ? series_fields.split(",") : [],
                chart_type = chart,
                res = JSON.parse(response);
            if(res.status == "error"){
                me.setState({
                    loading: false,
                    isError: true,
                    errorText: res.message
                })
                message.error(res.message)
                return;
            }
            //初始化设置字段别名
            let rename_filed=me.state.rename_filed;
				if(rename_filed&&rename_filed.counterItem_nick_name&&rename_filed.counterItem_nick_name.length>0&&y_axis_fields){
					for(let i=0;i<y_axis_fields.length;i++){
						rename_filed.counterItem_nick_name.forEach((item, d) => {
							if(item.label!=""&&item.value!=""){
                                if(y_axis_fields[i]===item.label){
                                    y_axis_fields[i]=item.value;	
                                }
                            }
						})

					}
				}
            let screenCategoriesArray = []; //需要分类的数据
            let normalCategoriesArray = []; //不需要分类的数据
            let highchartsCheck = {}; //判断highchart款高度需要的数组
            res.forEach((v, i) => {
                let arr = [];
                for(let k in v) {
                    for(let xAxisKey in x_axis_fields) {
                        x_axis_fields[xAxisKey] == k && arr.push(v[k])
                    }
                    k == x_axis_fields[x_axis_fields.length - 1] && normalCategoriesArray.push(v[k])
                }
                screenCategoriesArray.push(arr)
            })
    
            let categories = screenCategories(screenCategoriesArray) //分类的categories数据
            ///////////////////利用数据判断highcharts的宽高////////////////////////////
            for(let i of screenCategoriesArray) {
                for(let k in i) {
                    highchartsCheck[k] += i[k]
                }
            }
            let transitionWidth = 1
            for(let i in highchartsCheck) {
                transitionWidth < highchartsCheck[i].length && (transitionWidth = highchartsCheck[i].length)
            }
            let chartsData = []; //series数据
            let transitionArray = [];
            res && res.forEach((v, i) => {
                let a = {}
                for(let i in v) {
                    if(y_axis_fields.length > 0 && jQuery.inArray(i, y_axis_fields) != -1) {
                        a[i] = v[i]
                    }
                }
                transitionArray.push(a)
            })
            for(let i = 0; i < y_axis_fields.length; i++) {
                chartsData.push({
                    name: y_axis_fields[i],
                    data: [],
                    cursor: "pointer"
                })
            }
            transitionArray.forEach((dataV, i) => {
                for(let t in dataV) {
                    chartsData.forEach((v, i) => {
                        if(v.name == t) {
                            v.data.push(parseInt(dataV[t]))
                        }
                    })
                }
            })
            /////////////////////////////////////图表数据处理//////////////////////////////////////////////
            setting.series = chartsData;
            setting.xAxis.categories = chart_type == "pie" || chart_type == "polar" || chart_type == "gauge" ? normalCategoriesArray : categories;
            //处理饼图
            if(chart_type == "pie" && normalCategoriesArray && setting.series) {
                let pieChartsData = [];
                for(let a = 0; a < normalCategoriesArray.length; a++) {
                    pieChartsData.push([normalCategoriesArray[a]])
                }
                for(let b = 0; b < setting.series[0].data.length; b++) {
                    pieChartsData[b].push(parseInt(setting.series[0].data[b]))
                }
                setting.series = [{
                    type: "pie",
                    data: pieChartsData
                }]
            }
            me.forecolor_array.forEach((v, i) => {
                i == forecolor_value && (setting.colors = v)
            });
            if(chart_type.indexOf("stack_") >= 0) {
                //判断堆叠图
                setting.chart.type = chart_type.replace("stack_", "");
                setting.plotOptions.series.stacking = "normal";
            } else {
                setting.plotOptions.series.stacking = null;
                setting.chart.type = chart_type;
            }
            //如果是极地图
            setting.chart.polar = chart_type == "polar" ? !0 : !1;
            if(chart_type != "pie") {
                setting.series && setting.series.forEach(v => {
                    v.type = chart_type == "polar" ? "line" : ""
                })
            }
            if(chart_type == "gauge") {
                setting.pane = {
                    startAngle: -150,
                    endAngle: 150,
                    background: [{
                        backgroundColor: {
                            linearGradient: {
                                x1: 0,
                                y1: 0,
                                x2: 0,
                                y2: 1
                            },
                            stops: [
                                [0, '#FFF'],
                                [1, '#333']
                            ]
                        },
                        borderWidth: 0,
                        outerRadius: '109%'
                    }, {
                        backgroundColor: {
                            linearGradient: {
                                x1: 0,
                                y1: 0,
                                x2: 0,
                                y2: 1
                            },
                            stops: [
                                [0, '#333'],
                                [1, '#FFF']
                            ]
                        },
                        borderWidth: 1,
                        outerRadius: '107%'
                    }, {
                        // default background
                    }, {
                        backgroundColor: '#DDD',
                        borderWidth: 0,
                        outerRadius: '105%',
                        innerRadius: '103%'
                    }]
                }
    
                setting.yAxis = {
                    min: 0,
                    max: 200,
                    minorTickInterval: 'auto',
                    minorTickWidth: 1,
                    minorTickLength: 10,
                    minorTickPosition: 'inside',
                    minorTickColor: '#666',
                    tickPixelInterval: 30,
                    tickWidth: 2,
                    tickPosition: 'inside',
                    tickLength: 10,
                    tickColor: '#666',
                    labels: {
                        step: 2,
                        rotation: 'auto'
                    },
                    title: {
                        text: ''
                    },
                    plotBands: [{
                        from: 0,
                        to: 120,
                        color: '#55BF3B' // green
                    }, {
                        from: 120,
                        to: 160,
                        color: '#DDDF0D' // yellow
                    }, {
                        from: 160,
                        to: 200,
                        color: '#DF5353' // red
                    }]
                }
            } else {
                setting.pane = {};
                setting.yAxis = {};
            }
            setting.plotOptions.series.events.mouseOver = function (e) {
                let config = dataType;
                let thisName = e.target.name;
                let ouYuan = "";
                let numFormat="";
                config.forEach((v,i) => {
                    if(v.name == thisName){
                        if(v.money && v.money.money_type && v.money.money_type === "O"){
                            ouYuan = "€"
                        }else if (v.money && v.money.money_type && v.money.money_type != "O"){
                            ouYuan = v.money.money_type
                        }
                        if(v.digital&&v.digital.digital_format === "%"){
                            numFormat = "%";
                        }
                    }
                })
                if(ouYuan){
                    e.target.tooltipOptions.pointFormat = ` {point.category}: ${ouYuan}{point.y}`
                }else if(numFormat){
                    e.target.tooltipOptions.pointFormat = ` {point.category}: {point.y}${numFormat}`
                }else{
                    e.target.tooltipOptions.pointFormat = ` {point.category}:{point.y}`
                }
            }
            setting.plotOptions.series.point.events.click = function(e) {
                let obj = {}
                let params = {}
                let transition = e.point.category;
                if(chart_type == "pie") {
                    obj[x_axis_fields[x_axis_fields.length - 1]] = e.point.name;
                } else if(chart_type == "polar") {
                    obj[x_axis_fields[x_axis_fields.length - 1]] = e.point.category.name;
                } else if(chart_type == "gauge") {
                    message.info("仪表图暂不支持穿透功能")
                    return
                } else {
                    for(let i = x_axis_fields.length - 1; i >= 0; i--) {
                        
                        obj[x_axis_fields[i]] = transition.name
                        if(transition.parent) {
                            transition = transition.parent;
                        }
                    }
                }
                params.where = obj;
                params.searchParams = searchParams.concat(dataFilterParams)
                params.slot = me.state.slot
                params.linkType = me.state.link_type

                let tmpUU = this.series.name
				let initDatas = me.state.res;
				let currVal = [];
				currVal = initDatas.filter(function (item, index) {
					return  item[tmpUU] == e.point.y
				})
                params['linkValue'] = currVal
				params['value'] = e.point.y
                params['linkFiled'] = this.series.name
                let linkFlag = false;
                let newdataLink = me.state.dataLink;
                let newdataRename = me.state.rename_filed;
				let linkDatas = newdataLink.filter((v,n)=>{
					if(v.label === tmpUU){
						linkFlag = true
						return v
					}
				})
                
				let renameData =  newdataRename&&newdataRename.counterItem_nick_name&&newdataRename.counterItem_nick_name.length>0 && newdataRename.counterItem_nick_name.filter((v,n)=>{
					if(v.value === tmpUU) {
						linkDatas = newdataLink.filter((m,n)=>{
							if(m.label === v.label){
								linkFlag = true
								return m
							}
						})
						return linkFlag == true? v : null;
					}
                })
                
				if(linkFlag){
                    params['dataLink'] = linkDatas;
                    params['rename'] = renameData;
					$.post("/general/appbuilder/web/report/repchart/datalink",{
						i_dataset,
						params
					},response=>{
                        if (response.status != "ok") {
							let msg = response.message || '获取数据失败'
							message.error(msg);
						} else {
							let url = response.data;
							window.open(url, '_blank')
						}
					})
				}else{
                    params['dataLink'] = me.state.dataLink
					// t.getClickInfo({
                    //     i_dataset,
                    //     params
                    // }, () => {
                        t.setState({
                            currentClickInfo: params,
                            detailModalVisible: true
                        })
                    // })
                }
            }
            setting.plotOptions.series.events.legendItemClick= function(e) {
                const {
                    y_axis_fields,
                    chart_type
                } = me.state

                let rep_type;
                chartIdType.forEach((v, i) => {
                    v.id == chart_type && (rep_type = v.type)
                })
                    let num = 0,
                    eventDom = $(e.browserEvent.toElement).parents(".highcharts-legend-item"),
                    index = eventDom.prevAll().length;
                    let sign = ""
                    if(rep_type=="column"||rep_type=="stack_column"){
                     sign = "highcharts-legend-item highcharts-column-series highcharts-color-" + index + " highcharts-series-" + index;
                    }else if(rep_type=="bar"||rep_type=="stack_bar"){
                     sign = "highcharts-legend-item highcharts-bar-series highcharts-color-" + index + " highcharts-series-" + index;
                    }else if(rep_type=="line"||rep_type=="polar"){
                     sign = "highcharts-legend-item highcharts-line-series highcharts-color-" + index + " highcharts-series-" + index;
                    }else if(rep_type=="area"||rep_type=="stack_area"){
                     sign = "highcharts-legend-item highcharts-area-series highcharts-color-" + index + " highcharts-series-" + index;
                    }else if(rep_type=="scatter"){
                     sign = "highcharts-legend-item highcharts-scatter-series highcharts-color-" + index + " highcharts-series-" + index;
                    }else if(rep_type=="bubble"){
                     sign = "highcharts-legend-item highcharts-bubble-series highcharts-color-" + index + " highcharts-series-" + index;
                    }
                if($(eventDom).attr("class").trim() == sign.trim()) {
                    //如果要隐藏图例
                    if(y_axis_fields.length - 1 == $(e.browserEvent.toElement).parents(".highcharts-legend").find(".highcharts-legend-item-hidden").length) {
                        message.info("最少显示一个图例");
                        return false;
                    }
                }
                
            }
            let direction = ""
            if(chart_type == "column" || chart_type == "stack_column" || chart_type == "line" || chart_type == "area" || chart_type == "stack_area" || chart_type == "bubble"||chart_type == "scatter") {
                //修改宽度
                jQuery(".report-preview").css({
                    "width": this.state.mostWidth * 10,
                    "height": "100%"
                })
                direction = "width"
            } else if(chart_type == "bar" || chart_type == "stack_bar") {
                //修改高度
                jQuery(".report-preview").css({
                    "height": this.state.mostWidth * 10 * 0.65,
                    "width": "100%"
                })
                direction = "height"
            }else if(chart_type == "polar" || chart_type == "pie" || chart_type == "gauge"){
                direction = "normal"
                jQuery(".report-preview").css({
                    "height": "100%",
                    "width": "100%"
                })
            }
            		
            setting.tooltip = {
                headerFormat: '{series.name}<br>',
                pointFormat: ' {point.y}'
            },
        
            // console.log(transitionWidth)
            t.setState({
                mostWidth: transitionWidth,
                direction,
                x_axis_fields,
                y_axis_fields,
                res,
                loading: false
            })
            t.initInstance()
        }).error(function(e){
            me.setState({
                loading: false,
                isError: true,
                errorText: e.responseText
            })
        })
    }
}
let setting = {
	chart: {
		type: 'column',
		zoomType: 'xy',
		animation: true
	},
	title: {
		text: ''
	},
	legend: {
		layout: 'vertical',
		align: 'right',
		verticalAlign: 'top',
		x: -20,
		y: 50,
		floating: true,
		borderWidth: 1,
		backgroundColor: '#FFFFFF',
		shadow: true
	},
	pane: {},

	yAxis: {

	},
	xAxis: {
		tickmarkPlacement: "between",
		categories: null
	},
	credits: {
		enabled: false
	},
	plotOptions: {
		scatter: {
			tooltip: {
				headerFormat: '<b>{series.name}:{point.y}</b><br>',
				pointFormat: ''
			}
		},
		pie: {
			allowPointSelect: true,
			cursor: 'pointer',
			dataLabels: {
				enabled: true,
				format: '<b>{point.name}</b>: {point.percentage:.1f} %',
				style: {
					color: 'black'
				}
			},
			tooltip: {

			}
		},
		series: {
            events:{
                mouseOver: function(e) {

                }
            },
			point: {
				events: {
					click: function(e) {

					}
				}
			}
		}
	},
	scrollbar: {
		enabled: true
	},
	series: []
}
export default Chart
